require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_PARISC_ATOMIC_H_)) {
    eval 'sub _ASM_PARISC_ATOMIC_H_ () {1;}' unless defined(&_ASM_PARISC_ATOMIC_H_);
    if(defined(&__KERNEL__)) {
	require 'linux/config.ph';
	require 'asm/system.ph';
	if(defined(&CONFIG_SMP)) {
	    eval 'sub ATOMIC_HASH_SIZE () {4;}' unless defined(&ATOMIC_HASH_SIZE);
	    eval 'sub ATOMIC_HASH {
	        local($a) = @_;
    		eval q((& $__atomic_hash[(( $a)>>8)( &ATOMIC_HASH_SIZE-1)]));
	    }' unless defined(&ATOMIC_HASH);
	    eval 'sub SPIN_LOCK {
	        local($x) = @_;
    		eval q( &do {  &while( &__ldcw(($x)-> &lock) == 0); }  &while(0));
	    }' unless defined(&SPIN_LOCK);
	    eval 'sub SPIN_UNLOCK {
	        local($x) = @_;
    		eval q( &do { ($x)-> &lock = 1; }  &while(0));
	    }' unless defined(&SPIN_UNLOCK);
	} else {
	    eval 'sub ATOMIC_HASH_SIZE () {1;}' unless defined(&ATOMIC_HASH_SIZE);
	    eval 'sub ATOMIC_HASH {
	        local($a) = @_;
    		eval q((0));
	    }' unless defined(&ATOMIC_HASH);
	    eval 'sub SPIN_LOCK {
	        local($x) = @_;
    		eval q(($x));
	    }' unless defined(&SPIN_LOCK);
	    eval 'sub SPIN_UNLOCK {
	        local($x) = @_;
    		eval q( &do { }  &while(0));
	    }' unless defined(&SPIN_UNLOCK);
	}
	eval 'sub SPIN_LOCK_IRQSAVE {
	    local($lock, $flags) = @_;
    	    eval q( &do {  &local_irq_save($flags);  &SPIN_LOCK($lock); }  &while (0));
	}' unless defined(&SPIN_LOCK_IRQSAVE);
	eval 'sub SPIN_UNLOCK_IRQRESTORE {
	    local($lock, $flags) = @_;
    	    eval q( &do {  &SPIN_UNLOCK($lock);  &local_irq_restore($flags); }  &while (0));
	}' unless defined(&SPIN_UNLOCK_IRQRESTORE);
	if(defined(&__LP64__)) {
	}
	if(defined(&__LP64__)) {
	}
	eval 'sub xchg {
	    local($ptr,$x) = @_;
    	    eval q((( &__typeof__(*)) &__xchg(($x),($ptr),$sizeof{($ptr)})));
	}' unless defined(&xchg);
	eval 'sub __HAVE_ARCH_CMPXCHG () {1;}' unless defined(&__HAVE_ARCH_CMPXCHG);
	if(defined(&__LP64__)) {
	}
	eval 'sub cmpxchg {
	    local($ptr,$o,$n) = @_;
    	    eval q(({  &__typeof__(*)  &_o_ = ;  &__typeof__(*)  &_n_ = ; ( &__typeof__(*))  &__cmpxchg(,  &_o_,  &_n_, $sizeof{($ptr)}); }));
	}' unless defined(&cmpxchg);
	eval 'sub atomic_add {
	    local($i,$v) = @_;
    	    eval q((( &__atomic_add_return( ($i),($v)))));
	}' unless defined(&atomic_add);
	eval 'sub atomic_sub {
	    local($i,$v) = @_;
    	    eval q((( &__atomic_add_return(-($i),($v)))));
	}' unless defined(&atomic_sub);
	eval 'sub atomic_inc {
	    local($v) = @_;
    	    eval q((( &__atomic_add_return( 1,($v)))));
	}' unless defined(&atomic_inc);
	eval 'sub atomic_dec {
	    local($v) = @_;
    	    eval q((( &__atomic_add_return( -1,($v)))));
	}' unless defined(&atomic_dec);
	eval 'sub atomic_add_return {
	    local($i,$v) = @_;
    	    eval q(( &__atomic_add_return( ($i),($v))));
	}' unless defined(&atomic_add_return);
	eval 'sub atomic_sub_return {
	    local($i,$v) = @_;
    	    eval q(( &__atomic_add_return(-($i),($v))));
	}' unless defined(&atomic_sub_return);
	eval 'sub atomic_inc_return {
	    local($v) = @_;
    	    eval q(( &__atomic_add_return( 1,($v))));
	}' unless defined(&atomic_inc_return);
	eval 'sub atomic_dec_return {
	    local($v) = @_;
    	    eval q(( &__atomic_add_return( -1,($v))));
	}' unless defined(&atomic_dec_return);
	eval 'sub atomic_dec_and_test {
	    local($v) = @_;
    	    eval q(( &atomic_dec_return($v) == 0));
	}' unless defined(&atomic_dec_and_test);
	eval 'sub ATOMIC_INIT {
	    local($i) = @_;
    	    eval q({ ($i) });
	}' unless defined(&ATOMIC_INIT);
	eval 'sub smp_mb__before_atomic_dec () {
	    eval q( &smp_mb());
	}' unless defined(&smp_mb__before_atomic_dec);
	eval 'sub smp_mb__after_atomic_dec () {
	    eval q( &smp_mb());
	}' unless defined(&smp_mb__after_atomic_dec);
	eval 'sub smp_mb__before_atomic_inc () {
	    eval q( &smp_mb());
	}' unless defined(&smp_mb__before_atomic_inc);
	eval 'sub smp_mb__after_atomic_inc () {
	    eval q( &smp_mb());
	}' unless defined(&smp_mb__after_atomic_inc);
    }
}
1;
