require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_PARISC_BITOPS_H)) {
    eval 'sub _PARISC_BITOPS_H () {1;}' unless defined(&_PARISC_BITOPS_H);
    require 'linux/compiler.ph';
    require 'asm/system.ph';
    require 'asm/byteorder.ph';
    require 'asm/atomic.ph';
    if(defined(&__LP64__)) {
	eval 'sub SHIFT_PER_LONG () {6;}' unless defined(&SHIFT_PER_LONG);
	unless(defined(&BITS_PER_LONG)) {
	    eval 'sub BITS_PER_LONG () {64;}' unless defined(&BITS_PER_LONG);
	}
    } else {
	eval 'sub SHIFT_PER_LONG () {5;}' unless defined(&SHIFT_PER_LONG);
	unless(defined(&BITS_PER_LONG)) {
	    eval 'sub BITS_PER_LONG () {32;}' unless defined(&BITS_PER_LONG);
	}
    }
    eval 'sub CHOP_SHIFTCOUNT {
        local($x) = @_;
	    eval q((($x) & ( &BITS_PER_LONG - 1)));
    }' unless defined(&CHOP_SHIFTCOUNT);
    eval 'sub smp_mb__before_clear_bit () {
        eval q( &smp_mb());
    }' unless defined(&smp_mb__before_clear_bit);
    eval 'sub smp_mb__after_clear_bit () {
        eval q( &smp_mb());
    }' unless defined(&smp_mb__after_clear_bit);
    if(defined(&__KERNEL__)) {
	if((defined(&BITS_PER_LONG) ? &BITS_PER_LONG : 0) > 32) {
	} else {
	}
	eval 'sub ffz {
	    local($x) = @_;
    	    eval q( &__ffs(~$x));
	}' unless defined(&ffz);
	eval 'sub hweight64 {
	    local($x) = @_;
    	    eval q(({ \'unsigned long __x\' = ; \'unsigned int __w\';  &__w =  &generic_hweight32;  &__w +=  &generic_hweight32( ( &__x>>32));  &__w; }));
	}' unless defined(&hweight64);
	eval 'sub hweight32 {
	    local($x) = @_;
    	    eval q( &generic_hweight32($x));
	}' unless defined(&hweight32);
	eval 'sub hweight16 {
	    local($x) = @_;
    	    eval q( &generic_hweight16($x));
	}' unless defined(&hweight16);
	eval 'sub hweight8 {
	    local($x) = @_;
    	    eval q( &generic_hweight8($x));
	}' unless defined(&hweight8);
	unless(defined(&__LP64__)) {
	} else {
	}
    }
    eval 'sub find_first_zero_bit {
        local($addr, $size) = @_;
	    eval q( &find_next_zero_bit(($addr), ($size), 0));
    }' unless defined(&find_first_zero_bit);
    eval 'sub _EXT2_HAVE_ASM_BITOPS_ () {1;}' unless defined(&_EXT2_HAVE_ASM_BITOPS_);
    if(defined(&__KERNEL__)) {
	if(defined(&__LP64__)) {
	    eval 'sub ext2_set_bit {
	        local($nr, $addr) = @_;
    		eval q( &test_and_set_bit(($nr) ^ 0x38, $addr));
	    }' unless defined(&ext2_set_bit);
	    eval 'sub ext2_set_bit_atomic {
	        local($l,$nr,$addr) = @_;
    		eval q( &test_and_set_bit(($nr) ^ 0x38, $addr));
	    }' unless defined(&ext2_set_bit_atomic);
	    eval 'sub ext2_clear_bit {
	        local($nr, $addr) = @_;
    		eval q( &test_and_clear_bit(($nr) ^ 0x38, $addr));
	    }' unless defined(&ext2_clear_bit);
	    eval 'sub ext2_clear_bit_atomic {
	        local($l,$nr,$addr) = @_;
    		eval q( &test_and_clear_bit(($nr) ^ 0x38, $addr));
	    }' unless defined(&ext2_clear_bit_atomic);
	} else {
	    eval 'sub ext2_set_bit {
	        local($nr, $addr) = @_;
    		eval q( &test_and_set_bit(($nr) ^ 0x18, $addr));
	    }' unless defined(&ext2_set_bit);
	    eval 'sub ext2_set_bit_atomic {
	        local($l,$nr,$addr) = @_;
    		eval q( &test_and_set_bit(($nr) ^ 0x18, $addr));
	    }' unless defined(&ext2_set_bit_atomic);
	    eval 'sub ext2_clear_bit {
	        local($nr, $addr) = @_;
    		eval q( &test_and_clear_bit(($nr) ^ 0x18, $addr));
	    }' unless defined(&ext2_clear_bit);
	    eval 'sub ext2_clear_bit_atomic {
	        local($l,$nr,$addr) = @_;
    		eval q( &test_and_clear_bit(($nr) ^ 0x18, $addr));
	    }' unless defined(&ext2_clear_bit_atomic);
	}
    }
    eval 'sub ext2_find_first_zero_bit {
        local($addr, $size) = @_;
	    eval q( &ext2_find_next_zero_bit(($addr), ($size), 0));
    }' unless defined(&ext2_find_first_zero_bit);
    eval 'sub minix_test_and_set_bit {
        local($nr,$addr) = @_;
	    eval q( &ext2_set_bit($nr,$addr));
    }' unless defined(&minix_test_and_set_bit);
    eval 'sub minix_set_bit {
        local($nr,$addr) = @_;
	    eval q(( &ext2_set_bit($nr,$addr)));
    }' unless defined(&minix_set_bit);
    eval 'sub minix_test_and_clear_bit {
        local($nr,$addr) = @_;
	    eval q( &ext2_clear_bit($nr,$addr));
    }' unless defined(&minix_test_and_clear_bit);
    eval 'sub minix_test_bit {
        local($nr,$addr) = @_;
	    eval q( &ext2_test_bit($nr,$addr));
    }' unless defined(&minix_test_bit);
    eval 'sub minix_find_first_zero_bit {
        local($addr,$size) = @_;
	    eval q( &ext2_find_first_zero_bit($addr,$size));
    }' unless defined(&minix_find_first_zero_bit);
}
1;
