require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_PARISC_PAGE_H)) {
    eval 'sub _PARISC_PAGE_H () {1;}' unless defined(&_PARISC_PAGE_H);
    eval 'sub PAGE_SHIFT () {12;}' unless defined(&PAGE_SHIFT);
    eval 'sub PAGE_SIZE () {(1 <<  &PAGE_SHIFT);}' unless defined(&PAGE_SIZE);
    eval 'sub PAGE_MASK () {(~( &PAGE_SIZE-1));}' unless defined(&PAGE_MASK);
    if(defined(&__KERNEL__)) {
	require 'linux/config.ph';
	unless(defined(&__ASSEMBLY__)) {
	    require 'asm/cache.ph';
	    eval 'sub clear_page {
	        local($page) = @_;
    		eval q( &memset(($page), 0,  &PAGE_SIZE));
	    }' unless defined(&clear_page);
	    eval 'sub copy_page {
	        local($to,$from) = @_;
    		eval q( &copy_user_page_asm(, ($from)));
	    }' unless defined(&copy_page);
	    eval 'sub pte_val {
	        local($x) = @_;
    		eval q((($x). &pte));
	    }' unless defined(&pte_val);
	    eval 'sub pmd_val {
	        local($x) = @_;
    		eval q((($x). &pmd));
	    }' unless defined(&pmd_val);
	    eval 'sub pgd_val {
	        local($x) = @_;
    		eval q((($x). &pgd));
	    }' unless defined(&pgd_val);
	    eval 'sub pgprot_val {
	        local($x) = @_;
    		eval q((($x). &pgprot));
	    }' unless defined(&pgprot_val);
	    eval 'sub __pte {
	        local($x) = @_;
    		eval q((( &pte_t) { ($x) } ));
	    }' unless defined(&__pte);
	    eval 'sub __pmd {
	        local($x) = @_;
    		eval q((( &pmd_t) { ($x) } ));
	    }' unless defined(&__pmd);
	    eval 'sub __pgd {
	        local($x) = @_;
    		eval q((( &pgd_t) { ($x) } ));
	    }' unless defined(&__pgd);
	    eval 'sub __pgprot {
	        local($x) = @_;
    		eval q((( &pgprot_t) { ($x) } ));
	    }' unless defined(&__pgprot);
	    if(defined(&__LP64__)) {
		eval 'sub MAX_PHYSMEM_RANGES () {8;}' unless defined(&MAX_PHYSMEM_RANGES);
	    } else {
		eval 'sub MAX_PHYSMEM_RANGES () {1;}' unless defined(&MAX_PHYSMEM_RANGES);
	    }
	}
	eval 'sub PAGE_ALIGN {
	    local($addr) = @_;
    	    eval q(((($addr)+ &PAGE_SIZE-1) &PAGE_MASK));
	}' unless defined(&PAGE_ALIGN);
	eval 'sub LINUX_GATEWAY_SPACE () {0;}' unless defined(&LINUX_GATEWAY_SPACE);
	eval 'sub __PAGE_OFFSET () {(0x10000000);}' unless defined(&__PAGE_OFFSET);
	eval 'sub PAGE_OFFSET () {( &__PAGE_OFFSET);}' unless defined(&PAGE_OFFSET);
	if(defined(&__ASSEMBLY__)) {
	    eval 'sub PA {
	        local($x) = @_;
    		eval q((($x)- &__PAGE_OFFSET));
	    }' unless defined(&PA);
	    eval 'sub VA {
	        local($x) = @_;
    		eval q((($x)+ &__PAGE_OFFSET));
	    }' unless defined(&VA);
	}
	eval 'sub __pa {
	    local($x) = @_;
    	    eval q((($x)- &PAGE_OFFSET));
	}' unless defined(&__pa);
	eval 'sub __va {
	    local($x) = @_;
    	    eval q(((($x)+ &PAGE_OFFSET)));
	}' unless defined(&__va);
	eval 'sub pfn_to_page {
	    local($pfn) = @_;
    	    eval q(( &mem_map + ($pfn)));
	}' unless defined(&pfn_to_page);
	eval 'sub page_to_pfn {
	    local($page) = @_;
    	    eval q(((($page) -  &mem_map)));
	}' unless defined(&page_to_pfn);
	eval 'sub pfn_valid {
	    local($pfn) = @_;
    	    eval q((($pfn) <  &max_mapnr));
	}' unless defined(&pfn_valid);
	eval 'sub virt_addr_valid {
	    local($kaddr) = @_;
    	    eval q( &pfn_valid( &__pa($kaddr) >>  &PAGE_SHIFT));
	}' unless defined(&virt_addr_valid);
	unless(defined(&CONFIG_DISCONTIGMEM)) {
	    eval 'sub virt_to_page {
	        local($kaddr) = @_;
    		eval q(( &mem_map + ( &__pa($kaddr) >>  &PAGE_SHIFT)));
	    }' unless defined(&virt_to_page);
	    eval 'sub VALID_PAGE {
	        local($page) = @_;
    		eval q((($page -  &mem_map) <  &max_mapnr));
	    }' unless defined(&VALID_PAGE);
	}
	eval 'sub VM_DATA_DEFAULT_FLAGS () {( &VM_READ |  &VM_WRITE |  &VM_EXEC |  &VM_MAYREAD |  &VM_MAYWRITE |  &VM_MAYEXEC);}' unless defined(&VM_DATA_DEFAULT_FLAGS);
    }
}
1;
