require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ASM_PARISC_PROCESSOR_H)) {
    eval 'sub __ASM_PARISC_PROCESSOR_H () {1;}' unless defined(&__ASM_PARISC_PROCESSOR_H);
    unless(defined(&__ASSEMBLY__)) {
	require 'linux/config.ph';
	require 'linux/threads.ph';
	require 'asm/hardware.ph';
	require 'asm/page.ph';
	require 'asm/pdc.ph';
	require 'asm/ptrace.ph';
	require 'asm/types.ph';
	require 'asm/system.ph';
    }
    eval 'sub KERNEL_STACK_SIZE () {(4* &PAGE_SIZE);}' unless defined(&KERNEL_STACK_SIZE);
    eval 'sub current_text_addr () {
        eval q(({  &void * &pc;  &__asm__(\\"\\\\n\\\\tblr 0,%0\\\\n\\\\tnop\\":\\"=r\\" ( &pc));  &pc; }));
    }' unless defined(&current_text_addr);
    eval 'sub TASK_SIZE () {( ($current->{thread}->{task_size}));}' unless defined(&TASK_SIZE);
    eval 'sub TASK_UNMAPPED_BASE () {( ($current->{thread}->{map_base}));}' unless defined(&TASK_UNMAPPED_BASE);
    eval 'sub DEFAULT_TASK_SIZE32 () {(0xfff00000);}' unless defined(&DEFAULT_TASK_SIZE32);
    eval 'sub DEFAULT_MAP_BASE32 () {(0x40000000);}' unless defined(&DEFAULT_MAP_BASE32);
    if(defined(&__LP64__)) {
	eval 'sub DEFAULT_TASK_SIZE () {( &MAX_ADDRESS-0xf000000);}' unless defined(&DEFAULT_TASK_SIZE);
	eval 'sub DEFAULT_MAP_BASE () {(8589934592);}' unless defined(&DEFAULT_MAP_BASE);
    } else {
	eval 'sub DEFAULT_TASK_SIZE () { &DEFAULT_TASK_SIZE32;}' unless defined(&DEFAULT_TASK_SIZE);
	eval 'sub DEFAULT_MAP_BASE () { &DEFAULT_MAP_BASE32;}' unless defined(&DEFAULT_MAP_BASE);
    }
    unless(defined(&__ASSEMBLY__)) {
	if(defined(&CONFIG_SMP)) {
	}
	eval 'sub current_cpu_data () { $cpu_data[ &smp_processor_id()];}' unless defined(&current_cpu_data);
	eval 'sub CPU_HVERSION () {(( ($boot_cpu_data->{hversion}) >> 4) & 0xfff);}' unless defined(&CPU_HVERSION);
	eval 'sub MCA_bus () {0;}' unless defined(&MCA_bus);
	eval 'sub MCA_bus__is_a_macro () {1;}' unless defined(&MCA_bus__is_a_macro);
	eval 'sub PARISC_KERNEL_DEATH () {(1 << 31);}' unless defined(&PARISC_KERNEL_DEATH);
	eval 'sub INIT_THREAD () {{  &regs: {  &gr: { 0, },  &fr: { 0, },  &sr: { 0, },  &iasq: { 0, },  &iaoq: { 0, },  &cr27: 0, },  &task_size:  &DEFAULT_TASK_SIZE,  &map_base:  &DEFAULT_MAP_BASE,  &flags: 0};}' unless defined(&INIT_THREAD);
	eval 'sub start_thread_som {
	    local($regs, $new_pc, $new_sp) = @_;
    	    eval q( &do { \'unsigned long\' * &sp = $new_sp;  &__u32  &spaceid =  ($current->{mm}->{context}); \'unsigned long pc\' = $new_pc;  &pc |= 3;  &set_fs( &USER_DS);  ($regs->{iasq[0]}) =  &spaceid;  ($regs->{iasq[1]}) =  &spaceid;  ($regs->{iaoq[0]}) =  &pc;  ($regs->{iaoq[1]}) =  &pc + 4;  ($regs->{sr[2]}) =  &LINUX_GATEWAY_SPACE;  ($regs->{sr[3]}) = 0xffff;  ($regs->{sr[4]}) =  &spaceid;  ($regs->{sr[5]}) =  &spaceid;  ($regs->{sr[6]}) =  &spaceid;  ($regs->{sr[7]}) =  &spaceid;  ($regs->{gr[ 0]}) =  &USER_PSW;  ($regs->{gr[30]}) = (($new_sp)+63)&~63;  ($regs->{gr[31]}) =  &pc;  &get_user( ($regs->{gr[26]}), $sp[0]);  &get_user( ($regs->{gr[25]}), $sp[-1]);  &get_user( ($regs->{gr[24]}), $sp[-2]);  &get_user( ($regs->{gr[23]}), $sp[-3]); }  &while(0));
	}' unless defined(&start_thread_som);
	if(defined(&__LP64__)) {
	    eval 'sub USER_WIDE_MODE () {( &personality( ($current->{personality})) ==  &PER_LINUX);}' unless defined(&USER_WIDE_MODE);
	} else {
	    eval 'sub USER_WIDE_MODE () {0;}' unless defined(&USER_WIDE_MODE);
	}
	eval 'sub start_thread {
	    local($regs, $new_pc, $new_sp) = @_;
    	    eval q( &do {  &elf_addr_t * &sp = $new_sp;  &__u32  &spaceid =  ($current->{mm}->{context});  &elf_addr_t  &pc = $new_pc | 3;  &elf_caddr_t * &argv =  ($bprm->{exec}) + 1;  &set_fs;  ($regs->{iasq[0]}) =  &spaceid;  ($regs->{iasq[1]}) =  &spaceid;  ($regs->{iaoq[0]}) =  &pc;  ($regs->{iaoq[1]}) =  &pc + 4;  ($regs->{sr[2]}) =  &LINUX_GATEWAY_SPACE;  ($regs->{sr[3]}) = 0xffff;  ($regs->{sr[4]}) =  &spaceid;  ($regs->{sr[5]}) =  &spaceid;  ($regs->{sr[6]}) =  &spaceid;  ($regs->{sr[7]}) =  &spaceid;  ($regs->{gr[ 0]}) =  &USER_PSW | ( &USER_WIDE_MODE ?  &PSW_W : 0);  ($regs->{fr[ 0]}) = 0;  ($regs->{fr[ 1]}) = 0;  ($regs->{fr[ 2]}) = 0;  ($regs->{fr[ 3]}) = 0;  ($regs->{gr[30]}) = (( &sp + 63) &~ 63) | ( &USER_WIDE_MODE ? 1: 0);  ($regs->{gr[31]}) =  &pc;  &get_user( ($regs->{gr[25]}), ( &argv - 1));  ($regs->{gr[24]}) =  &argv;  ($regs->{gr[23]}) = 0; }  &while(0));
	}' unless defined(&start_thread);
	eval 'sub prepare_to_copy {
	    local($tsk) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&prepare_to_copy);
	eval 'sub KSTK_EIP {
	    local($tsk) = @_;
    	    eval q((($tsk)-> ($thread->{regs}->{iaoq[0]})));
	}' unless defined(&KSTK_EIP);
	eval 'sub KSTK_ESP {
	    local($tsk) = @_;
    	    eval q((($tsk)-> ($thread->{regs}->{gr[30]})));
	}' unless defined(&KSTK_ESP);
	if(defined(&CONFIG_PA20)) {
	    eval 'sub ARCH_HAS_PREFETCH () {1;}' unless defined(&ARCH_HAS_PREFETCH);
1;
