require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__PARISC_SYSTEM_H)) {
    eval 'sub __PARISC_SYSTEM_H () {1;}' unless defined(&__PARISC_SYSTEM_H);
    if(defined(&__KERNEL__)) {
	require 'linux/config.ph';
	require 'asm/psw.ph';
	if(defined(&__LP64__)) {
	    eval 'sub pa_psw {
	        local($task) = @_;
    		eval q(( ( ($task) +  &TASK_PT_PSW + 4)));
	    }' unless defined(&pa_psw);
	} else {
	    eval 'sub pa_psw {
	        local($task) = @_;
    		eval q(( ( ($task) +  &TASK_PT_PSW)));
	    }' unless defined(&pa_psw);
	}
	eval 'sub switch_to {
	    local($prev, $next, $last) = @_;
    	    eval q( &do { ($last) =  &_switch_to($prev, $next); }  &while(0));
	}' unless defined(&switch_to);
	eval 'sub local_save_flags {
	    local($x) = @_;
    	    eval q( &__asm__  &__volatile__(\\"ssm 0, %0\\" : \\"=r\\" ($x) : : \\"memory\\"));
	}' unless defined(&local_save_flags);
	eval 'sub local_irq_disable () {
	    eval q( &__asm__  &__volatile__(\\"rsm %0,%%r0\\\\n\\" : : \\"i\\" ( &PSW_I) : \\"memory\\" ));
	}' unless defined(&local_irq_disable);
	eval 'sub local_irq_enable () {
	    eval q( &__asm__  &__volatile__(\\"ssm %0,%%r0\\\\n\\" : : \\"i\\" ( &PSW_I) : \\"memory\\" ));
	}' unless defined(&local_irq_enable);
	eval 'sub local_irq_save {
	    local($x) = @_;
    	    eval q( &__asm__  &__volatile__(\\"rsm %1,%0\\" : \\"=r\\" ($x) :\\"i\\" ( &PSW_I) : \\"memory\\" ));
	}' unless defined(&local_irq_save);
	eval 'sub local_irq_restore {
	    local($x) = @_;
    	    eval q( &__asm__  &__volatile__(\\"mtsm %0\\" : : \\"r\\" ($x) : \\"memory\\" ));
	}' unless defined(&local_irq_restore);
	eval 'sub irqs_disabled () {
	    eval q(({ \'unsigned long flags\';  &local_save_flags( &flags); ( &flags &  &PSW_I) == 0; }));
	}' unless defined(&irqs_disabled);
	eval 'sub mfctl {
	    local($reg) = @_;
    	    eval q(({ \'unsigned long cr\';  &__asm__  &__volatile__( \\"mfctl \\" $reg \\",%0\\" : \\"=r\\" ( &cr) );  &cr; }));
	}' unless defined(&mfctl);
	eval 'sub mtctl {
	    local($gr, $cr) = @_;
    	    eval q( &__asm__  &__volatile__(\\"mtctl %0,%1\\" : : \\"r\\" ($gr), \\"i\\" ($cr)));
	}' unless defined(&mtctl);
	eval 'sub get_eiem () {
	    eval q( &mfctl(15));
	}' unless defined(&get_eiem);
	eval 'sub mfsp {
	    local($reg) = @_;
    	    eval q(({ \'unsigned long cr\';  &__asm__  &__volatile__( \\"mfsp \\" $reg \\",%0\\" : \\"=r\\" ( &cr) );  &cr; }));
	}' unless defined(&mfsp);
	eval 'sub mtsp {
	    local($gr, $cr) = @_;
    	    eval q( &__asm__  &__volatile__(\\"mtsp %0,%1\\" : : \\"r\\" ($gr), \\"i\\" ($cr)));
	}' unless defined(&mtsp);
	eval 'sub mb () {
	    eval q( &__asm__  &__volatile__(\\"\\":::\\"memory\\"););
	}' unless defined(&mb);
	eval 'sub rmb () {
	    eval q( &mb());
	}' unless defined(&rmb);
	eval 'sub wmb () {
	    eval q( &mb());
	}' unless defined(&wmb);
	eval 'sub smp_mb () {
	    eval q( &mb());
	}' unless defined(&smp_mb);
	eval 'sub smp_rmb () {
	    eval q( &mb());
	}' unless defined(&smp_rmb);
	eval 'sub smp_wmb () {
	    eval q( &mb());
	}' unless defined(&smp_wmb);
	eval 'sub smp_read_barrier_depends () {
	    eval q( &do { }  &while(0));
	}' unless defined(&smp_read_barrier_depends);
	eval 'sub read_barrier_depends () {
	    eval q( &do { }  &while(0));
	}' unless defined(&read_barrier_depends);
	eval 'sub set_mb {
	    local($var, $value) = @_;
    	    eval q( &do { $var = $value;  &mb(); }  &while (0));
	}' unless defined(&set_mb);
	eval 'sub set_wmb {
	    local($var, $value) = @_;
    	    eval q( &do { $var = $value;  &wmb(); }  &while (0));
	}' unless defined(&set_wmb);
	eval 'sub __ldcw {
	    local($a) = @_;
    	    eval q(({ \'unsigned __ret\';  &__asm__  &__volatile__(\\"ldcw 0(%1),%0\\" : \\"=r\\" ( &__ret) : \\"r\\" ($a));  &__ret; }));
	}' unless defined(&__ldcw);
	if(defined(&CONFIG_SMP)) {
	}
    }
}
1;
